[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.70 and 1.118

version 1.70, 2021/12/11 05:35:21 version 1.118, 2021/12/24 00:46:02
Line 15 
Line 15 
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF  # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.  # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 set -o errexit -o pipefail -o nounset  set -o errexit -o pipefail -o nounset -o noclobber -o noglob
   set +o monitor
   export PATH=/usr/bin:/bin:/usr/sbin:/sbin
   
 CFILE=SHA256.sig  CFILE=SHA256.sig
 DESTDIR=${DESTDIR:-}  DESTDIR=${DESTDIR:-}
Line 32 
Line 34 
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   VERBOSE=false
   DELETE=false
   DOWNLOAD=true
   INSTALL=true
 LOCALSRC=  LOCALSRC=
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
         # If we're not in the installer,          # If we're not in the installer,
         # we have mktemp and a more hostile environment          # we have mktemp and a more hostile environment.
         if [ -x /usr/bin/mktemp ]; then          if [ -x /usr/bin/mktemp ]; then
                 _dir=$( mktemp -d "${1}-XXXXXXXXX" )                  _dir=$( mktemp -d "${1}-XXXXXXXXX" )
         else          else
Line 51 
Line 57 
 }  }
   
 fetch() {  fetch() {
         local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''
   
         # If we're not in the installer, we have su(1)          # If we're not in the installer,
         # and doas(1) is unlikely to be configured.          # we have su(1) and doas(1) is unlikely to be configured.
           set -o monitor # make sure ftp gets its own process group
           (
           flags=-VM
           "$VERBOSE" && flags=-vm
         if [ -x /usr/bin/su ]; then          if [ -x /usr/bin/su ]; then
                 /usr/bin/su -s /bin/ksh "$_user" -c \                  exec /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"                      "/usr/bin/ftp -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"
                 _exit="$?"  
         else          else
                 /usr/bin/doas -u "$_user" \                  exec /usr/bin/doas -u "$_user" \
                     /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"                      /usr/bin/ftp -D 'Get/Verify' $flags -o- "$_src" > "$_dst"
                 _exit="$?"  
         fi          fi
           ) & _pid=$!
           set +o monitor
   
           trap "kill -TERM '-$_pid' 2>/dev/null; exit 1" EXIT INT QUIT ABRT TERM
   
           SECONDS=0
           _last=0
           while kill -0 -"$_pid" 2>/dev/null; do
                   if [[ $SECONDS -gt 12 ]]; then
                           set -- $( ls -ln "$_dst" 2>/dev/null )
                           if [[ $_last -ne $5 ]]; then
                                   _last=$5
                                   SECONDS=0
                                   sleep 1
                           else
                                   kill -INT -"$_pid"
                                   _error=" (timed out)"
                           fi
                   else
                           sleep 1
                   fi
           done
   
           set +o errexit
           wait "$_pid"
           _exit=$?
           set -o errexit
   
           trap "" EXIT INT QUIT ABRT TERM
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_dst"                  rm -f "$_dst"
                 echo "Cannot fetch $_src" >&2                  echo "Cannot fetch $_src$_error" >&2
                 return 1                  return 1
         fi          fi
 }  }
Line 81 
Line 118 
 }  }
   
 devices_needing_firmware() {  devices_needing_firmware() {
         local _d _m _grep _dmesgtail _last=''          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         # When we're not in the installer, the dmesg.boot can          # When we're not in the installer, the dmesg.boot can
         # contain multiple boots, so only look in the last one          # contain multiple boots, so only look in the last one
         _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )          _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
               grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
   
         grep -v '^[[:space:]]*#' "$FWPATTERNS" |          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
             while read -r _d _m; do              while read -r _d _m; do
                 _grep="grep"                  [ "$_d" = "$_last" ] && continue
                 [ "$_last" = "$_d" ] && continue                  [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                 [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "                  [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
                 [ "$_m" = "${_m#^}" ] && _grep="fgrep"  
   
                 echo "$_dmesgtail" | $_grep -q "$_m" || continue                  if [[ $_dmesgtail = *$_m* ]]; then
                 echo "$_d"                          echo "$_d"
                 _last="$_d"                          _last="$_d"
         done                  fi
               done
 }  }
   
 firmware_filename() {  firmware_filename() {
Line 114 
Line 152 
 }  }
   
 installed_firmware() {  installed_firmware() {
         for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do          local _pre="$1" _match="$2" _post="$3" _firmware
                 [ -e "$fw" ] || continue          set -A _firmware -- $(
               set +o noglob
               grep -Fxl '@option firmware' \
                   "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
                   2>/dev/null || true
               set -o noglob
           )
   
           [ "${_firmware[*]:-}" ] || return 0
           for fw in "${_firmware[@]}"; do
                   fw="${fw%/+CONTENTS}"
                 echo "${fw##*/}"                  echo "${fw##*/}"
         done          done
 }  }
   
 add_firmware () {  add_firmware () {
         local _f="${1##*/}" _pkgdir="${DESTDIR}/var/db/pkg"          local _f="${1##*/}" _pkgname
         ftp -D "Install" -Vmo- "file:${1}" |          local _tmpdir="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
                 tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \          local flags=-VM
           "$VERBOSE" && flags=-vm
           ftp -D "Install" "$flags" -o- "file:${1}" |
                   tar -s ",^\+,${_tmpdir}/+," \
                     -s ",^firmware,${DESTDIR}/etc/firmware," \                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                     -C / -zxphf - "+*" "firmware/*"                      -C / -zxphf - "+*" "firmware/*"
   
           _pkgname="$( sed -n '/^@name /{s///p;q;}' "${_tmpdir}/+CONTENTS" )"
           if [ ! "$_pkgname" ]; then
                   echo "Failed to extract name from $1, partial install" 2>&1
                   rm -rf "$_tmpdir"
                   return 1
           fi
   
         # TODO: Should we mark these so real fw_update can -Drepair?          # TODO: Should we mark these so real fw_update can -Drepair?
         ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL          ed -s "${_tmpdir}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 136 
Line 194 
 .  .
 w  w
 EOL  EOL
   
           chmod 755 "$_tmpdir"
           mv "$_tmpdir" "${DESTDIR}/var/db/pkg/${_pkgname}"
 }  }
   
 delete_firmware() {  delete_firmware() {
         local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
   
         # TODO: Check hash for files before deleting          # TODO: Check hash for files before deleting
         echo "Uninstalling $_pkg"          "$VERBOSE" && echo "Uninstalling $_pkg"
         _cwd="${_pkgdir}/$_pkg"          _cwd="${_pkgdir}/$_pkg"
   
           if [ ! -e "$_cwd/+CONTENTS" ] ||
               ! grep -Fxq '@option firmware' "$_cwd/+CONTENTS"; then
                   echo "${0##*/}: $_pkg does not appear to be firmware" >&2
                   return 2
           fi
   
         set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
   
         while read -r c g; do          while read -r c g; do
Line 164 
Line 231 
                 if [ -d "$_r" ]; then                  if [ -d "$_r" ]; then
                         # Try hard not to actually remove recursively                          # Try hard not to actually remove recursively
                         # without rmdir on the install media.                          # without rmdir on the install media.
                           set +o noglob
                         [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"                          [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                           set -o noglob
                 else                  else
                         rm -f "$_r"                          rm -f "$_r"
                 fi                  fi
Line 172 
Line 241 
 }  }
   
 usage() {  usage() {
         echo "usage: fw_install [-d dir | -L dir] [driver | file [...]]"          echo "usage:  ${0##*/} [-d | -D | -L] [-av] [driver | file ...]"
         exit 2          exit 2
 }  }
   
 INSTALL=true  ALL=false
 DOWNLOAD=true  OPT_D=
   OPT_L=
 while getopts dL name  while getopts :adDLv name
 do  do
        case "$name" in         case "$name" in
        # "download only" means local dir and don't install         a) ALL=true ;;
        d) LOCALSRC=. INSTALL=false ;;         d) DELETE=true ;;
        L) LOCALSRC=. ;;         D) OPT_D=true ;;
        ?) usage 2 ;;         L) OPT_L=true ;;
          v) VERBOSE=true ;;
          ?) echo "${0##*/}: unknown option -- -$OPTARG"; usage 2 ;;
        esac         esac
 done  done
 shift $((OPTIND - 1))  shift $((OPTIND - 1))
   
 # If we're installing from a local dir  [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
 # we don't want to download anything  
 [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false  
 [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"  
   
   if [ "$OPT_D" ]; then
           # "Download only" means local dir and don't install
           INSTALL=false
           LOCALSRC=.
   elif [ "$OPT_L" ]; then
           # "Local" means don't download, install from local dir
           DOWNLOAD=false
           LOCALSRC=.
   else
           LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
   fi
   
   CFILE="$LOCALSRC/$CFILE"
   
   if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
           echo "need root privileges" >&2
           exit 1
   fi
   
 set -A devices -- "$@"  set -A devices -- "$@"
   
 [ "${devices[*]:-}" ] ||  if "$DELETE"; then
     set -A devices -- $( devices_needing_firmware )          [ "$OPT_D" ] || [ "$OPT_L" ] && usage 22
   
 if [ ! "${devices[*]:-}" ]; then          set -A installed
         echo "No devices found which need firmware files to be downloaded."          if [ "${devices[*]:-}" ]; then
                   "$ALL" && usage 22
   
                   set -A installed -- $(
                       for d in "${devices[@]}"; do
                           f="${d##*/}"  # only care about the name
                           f="${f%.tgz}" # allow specifying the package name
                           [ "$( firmware_devicename "$f" )" = "$f" ] && f="$f-firmware"
   
                           set -A i -- $( installed_firmware '' "$f-" '*' )
   
                           if [ "${i[*]:-}" ]; then
                                   echo "${i[@]}"
                           else
                                   echo "No firmware found for '$d'" >&2
                           fi
                       done
                   )
           elif "$ALL"; then
                   set -A installed -- $( installed_firmware '*' '-firmware-' '*' )
           fi
   
           deleted=''
           if [ "${installed:-}" ]; then
                   for fw in "${installed[@]}"; do
                           delete_firmware "$fw" || continue
                           deleted="$deleted,$( firmware_devicename "$fw" )"
                   done
           fi
   
           deleted="${deleted:+${deleted#,}}"
           echo "${0:##*/}: deleted ${deleted:-none}";
   
         exit          exit
 fi  fi
   
 if "$DOWNLOAD" && ! [[ -e "$CFILE" ]]; then  if [ "${devices[*]:-}" ]; then
           "$ALL" && usage 22
   else
           "$VERBOSE" && echo -n "Detecting firmware ..."
           set -A devices -- $( devices_needing_firmware )
           "$VERBOSE" &&
               { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
   fi
   
   [ "${devices[*]:-}" ] || exit
   
   if "$DOWNLOAD"; then
           set +o noclobber # we want to get the latest CFILE
         fetch "$CFILE"          fetch "$CFILE"
           set -o noclobber
         ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
             echo "Signature check of SHA256.sig failed" >&2 && exit 1              echo "Signature check of SHA256.sig failed" >&2 && exit 1
 fi  fi
   
   added=''
   updated=''
   kept=''
 for f in "${devices[@]}"; do  for f in "${devices[@]}"; do
         d="$( firmware_devicename "$f" )"          d="$( firmware_devicename "$f" )"
   
Line 218 
Line 353 
                 f=$( firmware_filename "$d" || true )                  f=$( firmware_filename "$d" || true )
                 [ "$f" ] || continue                  [ "$f" ] || continue
                 f="$LOCALSRC/$f"                  f="$LOCALSRC/$f"
         elif ! "$INSTALL" && ! grep -q "($f)" "$CFILE" ; then          elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                 echo "Cannot download local file $f" >&2                  echo "Cannot download local file $f" >&2
                 exit 2                  exit 2
         fi          fi
   
         set -A installed -- $( installed_firmware "$d" )          set -A installed -- $( installed_firmware '' "$d-firmware-" '*' )
   
         if "$INSTALL" && [ "${installed[*]:-}" ]; then          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         if [ "${f##*/}" = "$i.tgz" ]; then                          if [ "${f##*/}" = "$i.tgz" ]; then
                                 echo "$i already installed"                                  "$VERBOSE" && echo "$i already installed"
                                   kept="$kept,$d"
                                 continue 2                                  continue 2
                         fi                          fi
                 done                  done
         fi          fi
   
         if [ ! -e "$f" ]; then          if [ -e "$f" ]; then
                 "$INSTALL" && ! "$DOWNLOAD" &&                  if "$DOWNLOAD"; then
                     echo "Cannot install ${f##*/}, not found" >&2 && continue                          "$VERBOSE" && echo "Verify existing ${f##*/}"
                           verify "$f" || continue
                           "$INSTALL"  || kept="$kept,$d"
                   # else assume it was verified when downloaded
                   fi
           elif "$DOWNLOAD"; then
                 fetch  "$f" || continue                  fetch  "$f" || continue
                 verify "$f" || continue                  verify "$f" || continue
         elif $DOWNLOAD; then                  "$INSTALL"  || added="$added,$d"
                 echo "Already have $f"          elif "$INSTALL"; then
                 verify "$f" || continue                  echo "Cannot install ${f##*/}, not found" >&2
                   continue
         fi          fi
   
         "$INSTALL" || continue          "$INSTALL" || continue
   
           removed=false
         if [ "${installed[*]:-}" ]; then          if [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         delete_firmware "$i"                          delete_firmware "$i"
                           removed=true
                 done                  done
         fi          fi
   
         add_firmware "$f"          add_firmware "$f"
   
           if "$removed"; then
                   updated="$updated,$d"
           else
                   added="$added,$d"
           fi
 done  done
   
   added="${added:#,}"
   updated="${updated:#,}"
   kept="${kept:#,}"
   if "$INSTALL"; then
           echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
   else
           echo  "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
   fi

Legend:
Removed from v.1.70  
changed lines
  Added in v.1.118

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>